'******************************************************************************
'
'                               BreakThru  1.0
'
'                               Tested on XP/ME
'                            Compiler - PB/Win 8.01
'
'                           by RValois, June 2005.
'                          email: pb@rvalois.com.br
'
'
'       This software is distributed in the hope that it will be useful,
'       but WITHOUT ANY WARRANTY; without even the implied warranty of
'       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
'
'
'                           USE AT YOUR OWN RISK
'
'******************************************************************************
'
#Compile Exe
#Dim All
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%WM_USER                                        = &H400
%Black                                          = &H000000???
%Blue                                           = &HFF0000???
%Green                                          = &H00FF00???
%Cyan                                           = &HFFFF00???
%Magenta                                        = &HFF00FF???
%Yellow                                         = &H00FFFF???
%White                                          = &HFFFFFF???
%VK_LEFT                                        = &H25
%VK_RIGHT                                       = &H27
%WM_CLOSE                                       = &H10
%WM_INITDIALOG                                  = &H110
%WS_CAPTION                                     = &H00C00000  ' WS_BORDER OR WS_DLGFRAME
%WS_SYSMENU                                     = &H00080000
%PM_REMOVE                                      = &H0001
%HWND_DESKTOP                                   = 0
%MB_OK                                          = &H00000000&
%SND_ASYNC                                      = &H1         ' play asynchronously
%TIME_PERIODIC                                  = 1  ' program for continuous periodic event

%MAX_PATH  = 260
Type RECT
  nLeft As Long
  nTop As Long
  nRight As Long
  nBottom As Long
End Type
Type POINTAPI
  x As Long
  y As Long
End Type
Type tagMSG
  hwnd As Dword
  message As Dword
  wParam As Long
  lParam As Long
  time As Dword
  pt As POINTAPI
End Type
Type Bitmap
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Word
  bmBitsPixel As Word
  bmBits As Byte Ptr
End Type
Declare Function GetAsyncKeyState Lib "USER32.DLL" Alias "GetAsyncKeyState" (ByVal vKey As Long) As Integer
Declare Function IntersectRect Lib "USER32.DLL" Alias "IntersectRect" (lpDestRect As RECT, lpSrc1Rect As RECT, lpSrc2Rect As RECT) As Long
Declare Function PeekMessage Lib "USER32.DLL" Alias "PeekMessageA" (lpMsg As tagMSG, ByVal hWnd As Dword, ByVal dwMsgFilterMin As Dword, ByVal dwMsgFilterMax As Dword, ByVal dwRemoveMsg As Dword) As Long
Declare Function PlaySound Lib "WINMM.DLL" Alias "PlaySoundA" (lpszName As Asciiz, ByVal hModule As Dword, ByVal dwFlags As Dword) As Long
Declare Function PostMessage Lib "USER32.DLL" Alias "PostMessageA" (ByVal hWnd As Dword, ByVal dwMsg As Dword, ByVal wParam As Dword, ByVal lParam As Long) As Long
Declare Function timeKillEvent Lib "WINMM.DLL" Alias "timeKillEvent" (ByVal uId As Dword) As Dword
Declare Function timeSetEvent Lib "WINMM.DLL" Alias "timeSetEvent" (ByVal uDelay As Dword, ByVal uResolution As Dword, ByVal lpFunction As Dword, ByVal dwUser As Dword, ByVal uFlags As Dword) As Dword
Declare Function GetWindowsDirectory Lib "KERNEL32.DLL" Alias "GetWindowsDirectoryA" (lpBuffer As Asciiz, ByVal nSize As Dword) As Dword
%IDC_GRAPHIC = 100
%GRAPH_W = 320
%GRAPH_H = 240
%PADDLE_W = 35
%PADDLE_H = 10
%PADDLE_POS_Y = 210
%PADDLE_SPEED = 4
%PADDLE_INIT_POS_X = 160
%BALL_D = 8
%BALL_SPEED = 2
%BRICK_W = 20
%BRICK_H = 8
%MAX_BRICK_LINE = 10
%MAX_BRICK_COL  = 13
%TEXT_W = 70
Global hGBmpPaddle As Long
Global PaddleXPos As Long
Global hGBmpBall As Long
Global BallVX As Long
Global BallVY As Long
Global BallX As Long
Global BallY As Long
Global nBalls As Long
Global hGBmpBrick As Long
Global BrickFallSpeed As Long
Global BrickStatus() As Long
Global BricksYOffset As Long
Global nPoints As Long
Global hMMTimer As Dword
Global GameSpeed As Long
Global WinDir As Asciiz * %MAX_PATH
Macro PlayStart = playsound(WinDir + "\media\start.wav",0, %SND_ASYNC)
Macro PlayChord = playsound(WinDir + "\media\chord.wav",0, %SND_ASYNC)
'******************************************************************************
Sub InitPaddle()
'******************************************************************************
  Graphic Bitmap New %PADDLE_W, %PADDLE_H To hGBmpPaddle
  Graphic Attach hGBmpPaddle, 0
  Graphic Box (0, 0) - (%PADDLE_W, %PADDLE_H), 100,%Cyan, %Cyan, 0
  Graphic Box (2, 2) - (%PADDLE_W-2, %PADDLE_H-2), 100, %Blue, %Blue, 0
  PaddleXPos = %PADDLE_INIT_POS_X
End Sub
'******************************************************************************
Sub InitBall()
'******************************************************************************
  Graphic Bitmap New %BALL_D , %BALL_D  To hGBmpBall
  Graphic Attach hGBmpBall, 0
  Graphic Ellipse (0, 0) - (%BALL_D , %BALL_D ), %Green, %Green, 0
  Graphic Ellipse (2, 2) - (%BALL_D-2 , %BALL_D-2 ), %White, %White, 0
  BallVX = %BALL_SPEED
  BallVY = %BALL_SPEED
  BallX = 80+Rnd(0,25)
  BallY = 120
End Sub
'******************************************************************************
Sub InitBrick()
'******************************************************************************
  Register x As Long
  Register y As Long
  ReDim BrickStatus(%MAX_BRICK_LINE,%MAX_BRICK_COL) As Global Long
  Graphic Bitmap New %BRICK_W, %BRICK_H To hGBmpBrick
  Graphic Attach hGBmpBrick, 0
  Graphic Box (0, 0) - (%BRICK_W, %BRICK_H), 80,  %Yellow, %Yellow, 0
  Graphic Box (2, 2) - (%BRICK_W-2, %BRICK_H-2), 80, %Magenta, %Magenta, 0
  For y = 0 To %MAX_BRICK_LINE
    For x = 0 To %MAX_BRICK_COL
      BrickStatus(y,x)=%True
    Next x
  Next y
  BricksYOffset = 2
End Sub
'******************************************************************************
Sub InitGame (ByVal hDlg As Dword)
'******************************************************************************
  Randomize
  GetWindowsDirectory(WinDir,%MAX_PATH)
  PlayStart
  PlayChord
  InitPaddle()
  InitBall()
  InitBrick()
  Graphic Attach hDlg, %IDC_GRAPHIC, ReDraw
  hMMTimer = timeSetEvent (GameSpeed, GameSpeed, CodePtr(MMTimerProc), hDlg, %TIME_PERIODIC)
End Sub
'******************************************************************************
Sub MMTimerProc  ( ByVal uID As Long, ByVal uMsg As Long, ByVal hDlg As Dword, ByVal lp1 As Long, ByVal lp2 As Long )
'******************************************************************************
  PostMessage (hDlg,%WM_USER+999,0,0)
End Sub
'******************************************************************************
Sub CleanUp (ByVal hDlg As Long)
'******************************************************************************
  Local Message As tagMSG
    If hMMTimer Then timeKillEvent(hMMTimer)
    hMMTimer = 0
    While PeekMessage(Message,hDlg,%WM_USER+999,%WM_USER+999,%PM_REMOVE)
    Wend
End Sub
'******************************************************************************
Sub EndGame (ByVal hDlg As Dword)
'******************************************************************************
  CleanUp(hDlg)
  Graphic Attach hGBmpPaddle, 0
  Graphic Bitmap End
  Graphic Attach hGBmpBall, 0
  Graphic Bitmap End
  Graphic Attach hGBmpBrick, 0
  Graphic Bitmap End
End Sub
'******************************************************************************
Sub UpdatePaddle()
'******************************************************************************
  Local ks As Word
  ks = GetAsyncKeyState(%VK_LEFT)
  If (ks And &h8000) And PaddleXPos>=%PADDLE_SPEED Then PaddleXPos = PaddleXPos - %PADDLE_SPEED
  ks = GetAsyncKeyState(%VK_RIGHT)
  If (ks And &h8000) And PaddleXPos<%GRAPH_W-%PADDLE_W-%PADDLE_SPEED Then PaddleXPos = PaddleXPos + %PADDLE_SPEED
End Sub
'******************************************************************************
Sub UpdateBrick(ByVal Count As Long)
'******************************************************************************
  If IsFalse (Count Mod BrickFallSpeed) Then Incr BricksYOffset
End Sub
'******************************************************************************
Sub BallBorderCollision()
'******************************************************************************
  If BallX<=0 Then
    BallVX=%BALL_SPEED
    PlayStart
  ElseIf BallX>=%GRAPH_W-%BALL_D Then
    BallVX=-%BALL_SPEED
    PlayStart
  ElseIf BallY<=0 Then
    BallVY=%BALL_SPEED
    PlayStart
  ElseIf BallY>=%GRAPH_H-%BALL_D Then
    BallVY=-%BALL_SPEED
    PlayChord
    Decr nBalls
  End If
End Sub
'******************************************************************************
Sub BallPaddleCollision(rBall As RECT)
'******************************************************************************
  Local rPaddle, rResult As RECT
  rPaddle.nLeft   = PaddleXPos
  rPaddle.nTop    = %PADDLE_POS_Y
  rPaddle.nRight  = PaddleXPos + %PADDLE_W
  rPaddle.nBottom = %PADDLE_POS_Y + %PADDLE_H
  If IntersectRect(rResult,rBall,rPaddle) Then
    If rResult.nLeft = rPaddle.nLeft Then BallVX=-%BALL_SPEED
    If rResult.nTop = rPaddle.nTop Then BallVY=-%BALL_SPEED
    If rResult.nRight = rPaddle.nRight Then BallVX=%BALL_SPEED
    If rResult.nBottom = rPaddle.nBottom Then BallVY=%BALL_SPEED
    PlayStart
  End If
End Sub
'******************************************************************************
Sub BallBrickCollision(rBall As RECT)
'******************************************************************************
  Register x As Long
  Register y As Long
  Local rBrick,rResult As RECT
  Local XIni,XEnd,YIni,YEnd As Long
  YIni = (rBall.nTop - BricksYOffset)\(%BRICK_H+2)
  XIni = (rBall.nLeft-8)\(%BRICK_W+2)
  XEnd = (rBall.nRight-8)\(%BRICK_W+2)
  yEnd = (rBall.nBottom - BricksYOffset)\(%BRICK_H+2)
  If XIni<0 Then XIni=0
  If XEnd>%MAX_BRICK_COL Then XEnd=%MAX_BRICK_COL
  If YIni<0 Then YIni=0
  If YEnd>%MAX_BRICK_LINE Then YEnd=%MAX_BRICK_LINE
  For y = YIni To YEnd
    For x = XIni To XEnd
      If BrickStatus(y,x) Then
        rBrick.nLeft    = 8 + x*(%BRICK_W+2)
        rBrick.nTop     = y*(%BRICK_H+2)+BricksYOffset
        rBrick.nRight   = rBrick.nLeft + %BRICK_W
        rBrick.nBottom  = rBrick.nTop + %BRICK_H
        If IntersectRect(rResult,rBall,rBrick) Then
          If rResult.nLeft = rBrick.nLeft Then BallVX=-%BALL_SPEED
          If rResult.nTop = rBrick.nTop Then BallVY=-%BALL_SPEED
          If rResult.nRight = rBrick.nRight Then BallVX=%BALL_SPEED
          If rResult.nBottom = rBrick.nBottom Then BallVY=%BALL_SPEED
          BrickStatus(y,x)=%False
          PlayStart
          nPoints = nPoints + 10
        End If
      End If
    Next x
  Next y
End Sub
'******************************************************************************
Function  DrawBrick() As Long
'******************************************************************************
  Register x As Long
  Register y As Long
  Local Result As Long
  For y = 0 To %MAX_BRICK_LINE
    For x = 0 To %MAX_BRICK_COL
      If BrickStatus(y,x) Then
        Graphic Copy hGBmpBrick, 0 To (8+x*(%BRICK_W+2), y*(%BRICK_H+2)+BricksYOffset)
        Incr Result
        If y*(%BRICK_H+2)+BricksYOffset+%BRICK_H>=%PADDLE_POS_Y Then
          Function = -1
          Exit Function
        End If
      End If
    Next x
  Next y
  Function = Result
End Function
'******************************************************************************
Sub UpdateBall()
'******************************************************************************
  BallX = BallX+BallVX
  BallY = BallY+BallVY
End Sub
'******************************************************************************
Sub WriteText()
'******************************************************************************
  Graphic Color %Yellow, %Black
  Graphic Font "Arial", 10, 1
  Graphic Set Pos (4, %PADDLE_POS_Y + %PADDLE_H + 2)
  Graphic Print "Pts:";nPoints
  Graphic Set Pos (%GRAPH_W - %TEXT_W, %PADDLE_POS_Y + %PADDLE_H + 2)
  Graphic Print "Balls: ";nBalls
End Sub
'******************************************************************************
Sub PlayerWon(ByVal hDlg As Dword, ByRef Count As Long)
'******************************************************************************
  If 63000-Count > 0 Then nPoints = nPoints + (63000-Count)\100
  nPoints = nPoints + nBalls*100
  WriteText()
  Graphic ReDraw
  MsgBox " Good!" + $CrLf + Str$(nPoints) + " Points",%MB_OK,"BreakThru"
  BrickFallSpeed = BrickFallSpeed - 50
  nBalls = nBalls + nPoints\1000
  GameSpeed = GameSpeed - 2
  Count=0
  If GameSpeed>0 Then InitGame hDlg
End Sub
'******************************************************************************
Sub PlayerLoose(ByVal hDlg As Dword, ByRef Count As Long)
'******************************************************************************
  WriteText()
  Graphic ReDraw
  MsgBox " End Game" + $CrLf + Str$(nPoints) + " Points",%MB_OK,"BreakThru"
  nPoints = 0
  BrickFallSpeed = 300
  nBalls = 10
  GameSpeed = 20
  Count=0
  InitGame hDlg
End Sub
'******************************************************************************
Sub PlayGame(ByVal hDlg As Long)
'******************************************************************************
  Local Result As Long
  Local Txt As String
  Local rBall As RECT
  Static Count As Long
  Incr Count
  Graphic Color %Black, %Black
  Graphic Clear
  UpdatePaddle()
  UpdateBrick(Count)
  UpdateBall()
  rBall.nLeft = BallX
  rBall.nTop = BallY
  rBall.nRight = rBall.nLeft +%BALL_D
  rBall.nBottom = rBall.nTop +%BALL_D
  BallBorderCollision()
  BallPaddleCollision(rBall)
  BallBrickCollision(rBall)
  Result = DrawBrick()
  WriteText()
  Graphic Copy hGBmpBall, 0 To (BallX, BallY)
  Graphic Copy hGBmpPaddle, 0 To (PaddleXPos, %PADDLE_POS_Y)
  Graphic ReDraw
  If Result = 0 Then
    CleanUp(hDlg)
    PlayerWon(hDlg,Count)
  ElseIf Result = -1 Or nBalls = 0 Then
    CleanUp(hDlg)
    PlayerLoose(hDlg,Count)
  End If

End Sub
'******************************************************************************
CallBack Function DlgProc () As Long
'******************************************************************************
  Select Case CbMsg
    Case %WM_INITDIALOG
      GameSpeed = 20
      BrickFallSpeed = 300
      nBalls = 10
      nPoints = 0
      InitGame CbHndl
    Case %WM_CLOSE
      EndGame CbHndl
    Case %WM_USER+999
      PlayGame(CbHndl)
  End Select
End Function
'******************************************************************************
Function PBMain () As Long
'******************************************************************************
  Local hDlg As Dword
  Dialog New Pixels, %HWND_DESKTOP, "BreakThru",,, %GRAPH_W, %GRAPH_H, %WS_CAPTION Or %WS_SYSMENU, 0 To hDlg
  Control Add Graphic, hDlg, %IDC_GRAPHIC, "", 0, 0, %GRAPH_W, %GRAPH_H
  Dialog Show Modal hDlg, Call DlgProc
End Function
'******************************************************************************
'END
'******************************************************************************
